package com.javaxing.mallstockbiz.service.impl;
import java.util.List;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import com.javaxing.mallstockbiz.mapper.SysShopStockMapper;
import com.javaxing.mallstockbiz.entity.SysShopStock;
import com.javaxing.mallstockbiz.service.SysShopStockService;
import org.springframework.transaction.annotation.Transactional;

@Service
public class SysShopStockServiceImpl implements SysShopStockService{

    @Resource
    private SysShopStockMapper sysShopStockMapper;

    @Override
    public int deleteByPrimaryKey(Integer id) {
        return sysShopStockMapper.deleteByPrimaryKey(id);
    }

    @Override
    public int insert(SysShopStock record) {
        return sysShopStockMapper.insert(record);
    }

    @Override
    public int insertSelective(SysShopStock record) {
        return sysShopStockMapper.insertSelective(record);
    }

    @Override
    public SysShopStock selectByPrimaryKey(Integer id) {
        return sysShopStockMapper.selectByPrimaryKey(id);
    }

    @Override
    public int updateByPrimaryKeySelective(SysShopStock record) {
        return sysShopStockMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int updateByPrimaryKey(SysShopStock record) {
        return sysShopStockMapper.updateByPrimaryKey(record);
    }

    @Override
    @Transactional
    public void reduceStock(Integer shopId, Integer count) {
        SysShopStock shopStock = sysShopStockMapper.findFirstByShopId(shopId);
        if(shopStock == null){
            throw new RuntimeException("商品不存在");
        }
        if(shopStock.getStock() < count){
            // 库存不够，抛出异常
            throw new RuntimeException("库存不足");
        }

        // 扣除库存
        int i = sysShopStockMapper.reduceStock(shopId,count);
        if(i==0){
            // 更新失败，抛出异常
            throw new RuntimeException("库存不足");
        }
    }

    @Override
	public SysShopStock findFirstByShopId(Integer shopId){
		 return sysShopStockMapper.findFirstByShopId(shopId);
	}



}
