package com.javaxing.malluserbiz.service.impl;

import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import com.javaxing.malluserbiz.entity.SysUser;
import com.javaxing.malluserbiz.mapper.SysUserMapper;
import com.javaxing.malluserbiz.service.SysUserService;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;

@Service
public class SysUserServiceImpl implements SysUserService{

    @Resource
    private SysUserMapper sysUserMapper;

    @Override
    public int deleteByPrimaryKey(Integer userId) {
        return sysUserMapper.deleteByPrimaryKey(userId);
    }

    @Override
    public int insert(SysUser record) {
        return sysUserMapper.insert(record);
    }

    @Override
    public int insertSelective(SysUser record) {
        return sysUserMapper.insertSelective(record);
    }

    @Override
    public SysUser selectByPrimaryKey(Integer userId) {
        return sysUserMapper.selectByPrimaryKey(userId);
    }

    @Override
    public int updateByPrimaryKeySelective(SysUser record) {
        return sysUserMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int updateByPrimaryKey(SysUser record) {
        return sysUserMapper.updateByPrimaryKey(record);
    }

    @Override
    @Transactional
    public void reduceBalance(Integer userId, BigDecimal balance) {
        // 检查用户余额是否足够
        SysUser user = sysUserMapper.selectByPrimaryKey(userId);
        if(user ==null){
            throw new RuntimeException("用户不存在");
        }
        if(balance.compareTo(user.getBalance()) == 1){
            throw new RuntimeException("余额不足");
        }

        // 扣除余额
        int i = sysUserMapper.reduceBalance(user.getUserId(), balance);
        if(i==0){
            throw new RuntimeException("扣除失败");
        }
    }
}
